# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for license information.
# Code generated by Microsoft (R) Python Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is regenerated.
# --------------------------------------------------------------------------

from azure.identity import DefaultAzureCredential

from azure.mgmt.devopsinfrastructure import DevOpsInfrastructureMgmtClient

"""
# PREREQUISITES
    pip install azure-identity
    pip install azure-mgmt-devopsinfrastructure
# USAGE
    python sku_list_by_location.py

    Before run the sample, please set the values of the client ID, tenant ID and client secret
    of the AAD application as environment variables: AZURE_CLIENT_ID, AZURE_TENANT_ID,
    AZURE_CLIENT_SECRET. For more info about how to get the value, please see:
    https://docs.microsoft.com/azure/active-directory/develop/howto-create-service-principal-portal
"""


def main():
    client = DevOpsInfrastructureMgmtClient(
        credential=DefaultAzureCredential(),
        subscription_id="SUBSCRIPTION_ID",
    )

    response = client.sku.list_by_location(
        location_name="eastus",
    )
    for item in response:
        print(item)


# x-ms-original-file: 2024-10-19/Sku_ListByLocation.json
if __name__ == "__main__":
    main()
